Index: server.go
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- server.go	(date 1512648581000)
+++ server.go	(date 1548547265000)
@@ -41,6 +41,8 @@
 
 var serverPool sync.Pool
 
+var serverSem = make(chan struct{}, 32)
+
 // Serve serves incoming connections from the given listener
 // using the given handler.
 //
@@ -1480,6 +1482,9 @@
 		connectionClose bool
 		isHTTP11        bool
 	)
+
+	semOpened := false
+
 	for {
 		connRequestNum++
 		ctx.time = currentTime
@@ -1491,6 +1496,8 @@
 				break
 			}
 		}
+		serverSem <- struct{}{}
+		semOpened = true
 
 		if !(s.ReduceMemoryUsage || ctx.lastReadDuration > time.Second) || br != nil {
 			if br == nil {
@@ -1565,6 +1572,9 @@
 		ctx.time = currentTime
 		s.Handler(ctx)
 
+		<-serverSem
+		semOpened = false
+
 		timeoutResponse = ctx.timeoutResponse
 		if timeoutResponse != nil {
 			ctx = s.acquireCtx(c)
@@ -1657,6 +1667,10 @@
 		currentTime = CoarseTimeNow()
 	}
 
+	if semOpened {
+		<-serverSem
+	}
+
 	if br != nil {
 		releaseReader(s, br)
 	}
